Subject: Re: Build error on -next in rust/kernel/usb.rs:92:34

From: Danilo Krummrich <[email-masked]>
Date: Mon, 3 Nov 2025 11:49:47 +0100

On 11/3/25 7:43 AM, Thorsten Leemhuis wrote:
> """
> error[E0599]: no method named `data` found for struct `core::pin::Pin<kbox::Box<T, Kmalloc>>` in the current scope
>   --> rust/kernel/usb.rs:92:34
>    |
> 92 |         T::disconnect(intf, data.data());
>    |                                  ^^^^ method not found in `core::pin::Pin<kbox::Box<T, Kmalloc>>`
> 
> error: aborting due to 1 previous error
> 
> For more information about this error, try `rustc --explain E0599`.
> make[2]: *** [rust/Makefile:553: rust/kernel.o] Error 1
> make[1]: *** [/builddir/build/BUILD/kernel-6.18.0-build/kernel-next-20251103/linux-6.18.0-0.0.next.20251103.436.vanilla.fc44.x86_64/Makefile:1316: prepare] Error 2
> make: *** [Makefile:256: __sub-make] Error 2
> """
> 
> Full log:
> https://download.copr.fedorainfracloud.org/results/@kernel-vanilla/next/fedora-rawhide-aarch64/09759703-next-next-all/builder-live.log.gz
> 
> A quick search for "T::disconnect(intf, data.data());" on lore
> lead me here:
> 
>> diff --git a/rust/kernel/usb.rs b/rust/kernel/usb.rs
>> index 9238b96c2185..05eed3f4f73e 100644
>> --- a/rust/kernel/usb.rs
>> +++ b/rust/kernel/usb.rs
>> @@ -87,9 +87,9 @@ extern "C" fn disconnect_callback(intf: *mut bindings::usb_interface) {
>>          // SAFETY: `disconnect_callback` is only ever called after a successful call to
>>          // `probe_callback`, hence it's guaranteed that `Device::set_drvdata()` has been called
>>          // and stored a `Pin<KBox<T>>`.
>> -        let data = unsafe { dev.drvdata_obtain::<Pin<KBox<T>>>() };
>> +        let data = unsafe { dev.drvdata_obtain::<T>() };
>>  
>> -        T::disconnect(intf, data.as_ref());
>> +        T::disconnect(intf, data.data());
>>      }
>>  }

This error is cause by commit 6bbaa93912bf ("rust: device: narrow the generic of
drvdata_obtain()").

It seems it slipped through, since the USB abstractions are disabled in all
trees other than the USB tree. I tested with enabling them locally, but it seems
I forgot to re-enable them after a rebase etc.

I will send a patch with the following fix:

diff --git a/rust/kernel/usb.rs b/rust/kernel/usb.rs
index 92215fdc3c6a..534e3ded5442 100644
--- a/rust/kernel/usb.rs
+++ b/rust/kernel/usb.rs
@@ -89,7 +89,7 @@ extern "C" fn disconnect_callback(intf: *mut
bindings::usb_interface) {
         // and stored a `Pin<KBox<T>>`.
         let data = unsafe { dev.drvdata_obtain::<T>() };

-        T::disconnect(intf, data.data());
+        T::disconnect(intf, data.as_ref());
     }
 }